Index: uspace/lib/posix/string.c
===================================================================
--- uspace/lib/posix/string.c	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/string.c	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -31,5 +31,5 @@
  * @{
  */
-/** @file
+/** @file String manipulation.
  */
 
@@ -48,9 +48,9 @@
 
 /**
- * Returns true if s2 is a prefix of s1.
- *
- * @param s1
- * @param s2
- * @return
+ * Decides whether s2 is a prefix of s1.
+ *
+ * @param s1 String in which to look for a prefix.
+ * @param s2 Prefix string to look for.
+ * @return True if s2 is a prefix of s1, false otherwise.
  */
 static bool begins_with(const char *s1, const char *s2)
@@ -69,7 +69,8 @@
  * if no occurence is found.
  *
- * @param s1
- * @param s2
- * @return
+ * @param s1 String in which to look for the bytes.
+ * @param s2 String of bytes to look for.
+ * @return Pointer to the found byte on success, pointer to the
+ *     string terminator otherwise.
  */
 static char *strpbrk_null(const char *s1, const char *s2)
@@ -83,10 +84,11 @@
 
 /**
- *
- * @param dest
- * @param src
- * @return
- */
-char *posix_strcpy(char *dest, const char *src)
+ * Copy a string.
+ *
+ * @param dest Destination pre-allocated buffer.
+ * @param src Source string to be copied.
+ * @return Pointer to the destination buffer.
+ */
+char *posix_strcpy(char *restrict dest, const char *restrict src)
 {
 	posix_stpcpy(dest, src);
@@ -95,11 +97,12 @@
 
 /**
- *
- * @param dest
- * @param src
- * @param n
- * @return
- */
-char *posix_strncpy(char *dest, const char *src, size_t n)
+ * Copy fixed length string.
+ *
+ * @param dest Destination pre-allocated buffer.
+ * @param src Source string to be copied.
+ * @param n Number of bytes to be stored into destination buffer.
+ * @return Pointer to the destination buffer.
+ */
+char *posix_strncpy(char *restrict dest, const char *restrict src, size_t n)
 {
 	posix_stpncpy(dest, src, n);
@@ -108,8 +111,9 @@
 
 /**
- *
- * @param dest
- * @param src
- * @return Pointer to the nul character in the dest string
+ * Copy a string.
+ *
+ * @param dest Destination pre-allocated buffer.
+ * @param src Source string to be copied.
+ * @return Pointer to the nul character in the destination string.
  */
 char *posix_stpcpy(char *restrict dest, const char *restrict src)
@@ -132,9 +136,10 @@
 
 /**
- *
- * @param dest
- * @param src
- * @param n
- * @return Pointer to the first written nul character or &dest[n]
+ * Copy fixed length string.
+ *
+ * @param dest Destination pre-allocated buffer.
+ * @param src Source string to be copied.
+ * @param n Number of bytes to be stored into destination buffer.
+ * @return Pointer to the first written nul character or &dest[n].
  */
 char *posix_stpncpy(char *restrict dest, const char *restrict src, size_t n)
@@ -162,10 +167,11 @@
 
 /**
- *
- * @param dest
- * @param src
- * @return
- */
-char *posix_strcat(char *dest, const char *src)
+ * Concatenate two strings.
+ *
+ * @param dest String to which src shall be appended.
+ * @param src String to be appended after dest.
+ * @return Pointer to destination buffer.
+ */
+char *posix_strcat(char *restrict dest, const char *restrict src)
 {
 	assert(dest != NULL);
@@ -177,11 +183,12 @@
 
 /**
- *
- * @param dest
- * @param src
- * @param n
- * @return
- */
-char *posix_strncat(char *dest, const char *src, size_t n)
+ * Concatenate a string with part of another.
+ *
+ * @param dest String to which part of src shall be appended.
+ * @param src String whose part shall be appended after dest.
+ * @param n Number of bytes to append after dest.
+ * @return Pointer to destination buffer.
+ */
+char *posix_strncat(char *restrict dest, const char *restrict src, size_t n)
 {
 	assert(dest != NULL);
@@ -195,12 +202,13 @@
 
 /**
- *
- * @param dest
- * @param src
- * @param c
- * @param n
+ * Copy limited number of bytes in memory.
+ *
+ * @param dest Destination buffer.
+ * @param src Source buffer.
+ * @param c Character after which the copying shall stop.
+ * @param n Number of bytes that shall be copied if not stopped earlier by c.
  * @return Pointer to the first byte after c in dest if found, NULL otherwise.
  */
-void *posix_memccpy(void *dest, const void *src, int c, size_t n)
+void *posix_memccpy(void *restrict dest, const void *restrict src, int c, size_t n)
 {
 	assert(dest != NULL);
@@ -223,7 +231,8 @@
 
 /**
- *
- * @param s
- * @return Newly allocated string
+ * Duplicate a string.
+ *
+ * @param s String to be duplicated.
+ * @return Newly allocated copy of the string.
  */
 char *posix_strdup(const char *s)
@@ -233,8 +242,9 @@
 
 /**
- *
- * @param s
- * @param n
- * @return Newly allocated string of length at most n
+ * Duplicate a specific number of bytes from a string.
+ *
+ * @param s String to be duplicated.
+ * @param n Maximum length of the resulting string..
+ * @return Newly allocated string copy of length at most n.
  */
 char *posix_strndup(const char *s, size_t n)
@@ -255,10 +265,11 @@
 
 /**
- *
- * @param mem1
- * @param mem2
- * @param n
+ * Compare bytes in memory.
+ *
+ * @param mem1 First area of memory to be compared.
+ * @param mem2 Second area of memory to be compared.
+ * @param n Maximum number of bytes to be compared.
  * @return Difference of the first pair of inequal bytes,
- *     or 0 if areas have the same content
+ *     or 0 if areas have the same content.
  */
 int posix_memcmp(const void *mem1, const void *mem2, size_t n)
@@ -272,5 +283,5 @@
 	for (size_t i = 0; i < n; ++i) {
 		if (s1[i] != s2[i]) {
-			return s2[i] - s1[i];
+			return s1[i] - s2[i];
 		}
 	}
@@ -280,8 +291,10 @@
 
 /**
- *
- * @param s1
- * @param s2
- * @return
+ * Compare two strings.
+ *
+ * @param s1 First string to be compared.
+ * @param s2 Second string to be compared.
+ * @return Difference of the first pair of inequal characters,
+ *     or 0 if strings have the same content.
  */
 int posix_strcmp(const char *s1, const char *s2)
@@ -294,9 +307,11 @@
 
 /**
- *
- * @param s1
- * @param s2
- * @param n
- * @return
+ * Compare part of two strings.
+ *
+ * @param s1 First string to be compared.
+ * @param s2 Second string to be compared.
+ * @param n Maximum number of characters to be compared.
+ * @return Difference of the first pair of inequal characters,
+ *     or 0 if strings have the same content.
  */
 int posix_strncmp(const char *s1, const char *s2, size_t n)
@@ -307,5 +322,5 @@
 	for (size_t i = 0; i < n; ++i) {
 		if (s1[i] != s2[i]) {
-			return s2[i] - s1[i];
+			return s1[i] - s2[i];
 		}
 		if (s1[i] == '\0') {
@@ -318,9 +333,11 @@
 
 /**
- *
- * @param mem
- * @param c
- * @param n
- * @return
+ * Find byte in memory.
+ *
+ * @param mem Memory area in which to look for the byte.
+ * @param c Byte to look for.
+ * @param n Maximum number of bytes to be inspected.
+ * @return Pointer to the specified byte on success,
+ *     NULL pointer otherwise.
  */
 void *posix_memchr(const void *mem, int c, size_t n)
@@ -339,8 +356,10 @@
 
 /**
- *
- * @param s
- * @param c
- * @return
+ * Scan string for a first occurence of a character.
+ *
+ * @param s String in which to look for the character.
+ * @param c Character to look for.
+ * @return Pointer to the specified character on success,
+ *     NULL pointer otherwise.
  */
 char *posix_strchr(const char *s, int c)
@@ -353,8 +372,10 @@
 
 /**
- *
- * @param s
- * @param c
- * @return
+ * Scan string for a last occurence of a character.
+ *
+ * @param s String in which to look for the character.
+ * @param c Character to look for.
+ * @return Pointer to the specified character on success,
+ *     NULL pointer otherwise.
  */
 char *posix_strrchr(const char *s, int c)
@@ -376,4 +397,12 @@
 }
 
+/**
+ * Scan string for a first occurence of a character.
+ *
+ * @param s String in which to look for the character.
+ * @param c Character to look for.
+ * @return Pointer to the specified character on success, pointer to the
+ *     string terminator otherwise.
+ */
 char *gnu_strchrnul(const char *s, int c)
 {
@@ -388,8 +417,10 @@
 
 /**
- *
- * @param s1
- * @param s2
- * @return
+ * Scan a string for a first occurence of one of provided bytes.
+ *
+ * @param s1 String in which to look for the bytes.
+ * @param s2 String of bytes to look for.
+ * @return Pointer to the found byte on success,
+ *     NULL pointer otherwise.
  */
 char *posix_strpbrk(const char *s1, const char *s2)
@@ -403,8 +434,9 @@
 
 /**
- *
- * @param s1
- * @param s2
- * @return
+ * Get the length of a complementary substring.
+ *
+ * @param s1 String that shall be searched for complementary prefix.
+ * @param s2 String of bytes that shall not occur in the prefix.
+ * @return Length of the prefix.
  */
 size_t posix_strcspn(const char *s1, const char *s2)
@@ -418,8 +450,9 @@
 
 /**
- *
- * @param s1
- * @param s2
- * @return
+ * Get length of a substring.
+ *
+ * @param s1 String that shall be searched for prefix.
+ * @param s2 String of bytes that the prefix must consist of.
+ * @return Length of the prefix.
  */
 size_t posix_strspn(const char *s1, const char *s2)
@@ -438,8 +471,10 @@
 
 /**
- *
- * @param s1
- * @param s2
- * @return
+ * Find a substring.
+ *
+ * @param s1 String in which to look for a substring.
+ * @param s2 Substring to look for.
+ * @return Pointer to the first character of the substring in s1, or NULL if
+ *     not found.
  */
 char *posix_strstr(const char *s1, const char *s2)
@@ -467,9 +502,12 @@
 
 /**
+ * String comparison using collating information.
+ *
  * Currently ignores locale and just calls strcmp.
  *
- * @param s1
- * @param s2
- * @return
+ * @param s1 First string to be compared.
+ * @param s2 Second string to be compared.
+ * @return Difference of the first pair of inequal characters,
+ *     or 0 if strings have the same content.
  */
 int posix_strcoll(const char *s1, const char *s2)
@@ -482,12 +520,16 @@
 
 /**
- * strcoll is equal to strcmp here, so this just makes a copy.
- *
- * @param s1
- * @param s2
- * @param n
- * @return
- */
-size_t posix_strxfrm(char *s1, const char *s2, size_t n)
+ * Transform a string in such a way that the resulting string yields the same
+ * results when passed to the strcmp as if the original string is passed to
+ * the strcoll.
+ *
+ * Since strcoll is equal to strcmp here, this just makes a copy.
+ *
+ * @param s1 Transformed string.
+ * @param s2 Original string.
+ * @param n Maximum length of the transformed string.
+ * @return Length of the transformed string.
+ */
+size_t posix_strxfrm(char *restrict s1, const char *restrict s2, size_t n)
 {
 	assert(s1 != NULL || n == 0);
@@ -504,7 +546,8 @@
 
 /**
- *
- * @param errnum
- * @return
+ * Get error message string.
+ *
+ * @param errnum Error code for which to obtain human readable string.
+ * @return Error message.
  */
 char *posix_strerror(int errnum)
@@ -518,9 +561,10 @@
 
 /**
- *
- * @param errnum Error code
- * @param buf Buffer to store a human readable string to
- * @param bufsz Size of buffer pointed to by buf
- * @return
+ * Get error message string.
+ *
+ * @param errnum Error code for which to obtain human readable string.
+ * @param buf Buffer to store a human readable string to.
+ * @param bufsz Size of buffer pointed to by buf.
+ * @return Zero on success, errno otherwise.
  */
 int posix_strerror_r(int errnum, char *buf, size_t bufsz)
@@ -541,7 +585,8 @@
 
 /**
- *
- * @param s
- * @return
+ * Get length of the string.
+ *
+ * @param s String which length shall be determined.
+ * @return Length of the string.
  */
 size_t posix_strlen(const char *s)
@@ -553,8 +598,9 @@
 
 /**
- *
- * @param s
- * @param n
- * @return
+ * Get limited length of the string.
+ *
+ * @param s String which length shall be determined.
+ * @param n Maximum number of bytes that can be examined to determine length.
+ * @return The lower of either string length or n limit.
  */
 size_t posix_strnlen(const char *s, size_t n)
@@ -573,7 +619,8 @@
 
 /**
- *
- * @param signum
- * @return
+ * Get description of a signal.
+ *
+ * @param signum Signal number.
+ * @return Human readable signal description.
  */
 char *posix_strsignal(int signum)
Index: uspace/lib/posix/string.h
===================================================================
--- uspace/lib/posix/string.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/string.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -31,5 +31,5 @@
  * @{
  */
-/** @file
+/** @file String manipulation.
  */
 
@@ -103,8 +103,8 @@
 extern size_t posix_strnlen(const char *s, size_t n);
 
-/* Signal messages */
+/* Signal Messages */
 extern char *posix_strsignal(int signum);
 
-/* Legacy declarations */
+/* Legacy Declarations */
 #ifndef POSIX_STRINGS_H_
 extern int posix_ffs(int i);
Index: uspace/lib/posix/strings.c
===================================================================
--- uspace/lib/posix/strings.c	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/strings.c	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -31,5 +31,5 @@
  * @{
  */
-/** @file
+/** @file Additional string manipulation.
  */
 
@@ -45,7 +45,8 @@
 
 /**
+ * Find first set bit (beginning with the least significant bit).
  *
- * @param i
- * @return
+ * @param i Integer in which to look for the first set bit.
+ * @return Index of first set bit. Bits are numbered starting at one.
  */
 int posix_ffs(int i)
@@ -82,8 +83,10 @@
 
 /**
+ * Compare two strings (case-insensitive).
  *
- * @param s1
- * @param s2
- * @return
+ * @param s1 First string to be compared.
+ * @param s2 Second string to be compared.
+ * @return Difference of the first pair of inequal characters,
+ *     or 0 if strings have the same content.
  */
 int posix_strcasecmp(const char *s1, const char *s2)
@@ -93,9 +96,11 @@
 
 /**
+ * Compare part of two strings (case-insensitive).
  *
- * @param s1
- * @param s2
- * @param n
- * @return
+ * @param s1 First string to be compared.
+ * @param s2 Second string to be compared.
+ * @param n Maximum number of characters to be compared.
+ * @return Difference of the first pair of inequal characters,
+ *     or 0 if strings have the same content.
  */
 int posix_strncasecmp(const char *s1, const char *s2, size_t n)
@@ -116,9 +121,11 @@
 
 /**
+ * Compare two memory areas.
  *
- * @param mem1
- * @param mem2
- * @param n
- * @return
+ * @param mem1 Pointer to the first area to compare.
+ * @param mem2 Pointer to the second area to compare.
+ * @param n Common size of both areas.
+ * @return If n is 0, return zero. If the areas match, return
+ *     zero. Otherwise return non-zero.
  */
 int posix_bcmp(const void *mem1, const void *mem2, size_t n)
@@ -128,19 +135,21 @@
 
 /**
+ * Copy bytes in memory with overlapping areas.
  *
- * @param dest
- * @param src
- * @param n
+ * @param src Source area.
+ * @param dest Destination area.
+ * @param n Number of bytes to copy.
  */
-void posix_bcopy(const void *dest, void *src, size_t n)
+void posix_bcopy(const void *src, void *dest, size_t n)
 {
 	/* Note that memmove has different order of arguments. */
-	memmove(src, dest, n);
+	memmove(dest, src, n);
 }
 
 /**
+ * Reset bytes in memory area to zero.
  *
- * @param mem
- * @param n
+ * @param mem Memory area to be zeroed.
+ * @param n Number of bytes to reset.
  */
 void posix_bzero(void *mem, size_t n)
@@ -150,8 +159,10 @@
 
 /**
+ * Scan string for a first occurence of a character.
  *
- * @param s
- * @param c
- * @return
+ * @param s String in which to look for the character.
+ * @param c Character to look for.
+ * @return Pointer to the specified character on success,
+ *     NULL pointer otherwise.
  */
 char *posix_index(const char *s, int c)
@@ -161,8 +172,10 @@
 
 /**
- * 
- * @param s
- * @param c
- * @return
+ * Scan string for a last occurence of a character.
+ *
+ * @param s String in which to look for the character.
+ * @param c Character to look for.
+ * @return Pointer to the specified character on success,
+ *     NULL pointer otherwise.
  */
 char *posix_rindex(const char *s, int c)
Index: uspace/lib/posix/strings.h
===================================================================
--- uspace/lib/posix/strings.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/strings.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -31,5 +31,5 @@
  * @{
  */
-/** @file
+/** @file Additional string manipulation.
  */
 
@@ -37,6 +37,6 @@
 #define POSIX_STRINGS_H_
 
+/* Search Functions */
 #ifndef POSIX_STRING_H_
-/* Search Functions */
 extern int posix_ffs(int i);
 #endif
@@ -56,5 +56,5 @@
 /* Legacy Functions */
 extern int posix_bcmp(const void *mem1, const void *mem2, size_t n);
-extern void posix_bcopy(const void *dest, void *src, size_t n);
+extern void posix_bcopy(const void *src, void *dest, size_t n);
 extern void posix_bzero(void *mem, size_t n);
 extern char *posix_index(const char *s, int c);
Index: uspace/lib/posix/sys/mman.h
===================================================================
--- uspace/lib/posix/sys/mman.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/sys/mman.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -30,5 +30,5 @@
  * @{
  */
-/** @file
+/** @file Memory management declarations.
  */
 
Index: uspace/lib/posix/sys/stat.c
===================================================================
--- uspace/lib/posix/sys/stat.c	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/sys/stat.c	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -31,5 +31,5 @@
  * @{
  */
-/** @file
+/** @file File status handling.
  */
 
@@ -80,6 +80,5 @@
 	int rc = fstat(fd, &hst);
 	if (rc < 0) {
-		/* fstat() returns negative error code instead of using errno.
-		 */
+		/* fstat() returns negative error code instead of using errno. */
 		errno = -rc;
 		return -1;
@@ -96,5 +95,5 @@
  * @return Zero on success, -1 otherwise.
  */
-int posix_lstat(const char *path, struct posix_stat *st)
+int posix_lstat(const char *restrict path, struct posix_stat *restrict st)
 {
 	/* There are currently no symbolic links in HelenOS. */
@@ -109,11 +108,10 @@
  * @return Zero on success, -1 otherwise.
  */
-int posix_stat(const char *path, struct posix_stat *st)
+int posix_stat(const char *restrict path, struct posix_stat *restrict st)
 {
 	struct stat hst;
 	int rc = stat(path, &hst);
 	if (rc < 0) {
-		/* stat() returns negative error code instead of using errno.
-		 */
+		/* stat() returns negative error code instead of using errno. */
 		errno = -rc;
 		return -1;
Index: uspace/lib/posix/sys/stat.h
===================================================================
--- uspace/lib/posix/sys/stat.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/sys/stat.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -31,5 +31,5 @@
  * @{
  */
-/** @file
+/** @file File status handling.
  */
 
Index: uspace/lib/posix/sys/types.h
===================================================================
--- uspace/lib/posix/sys/types.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/sys/types.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -31,5 +31,5 @@
  * @{
  */
-/** @file
+/** @file Data types definitions.
  */
 
@@ -49,8 +49,8 @@
 typedef sysarg_t posix_dev_t;
 
-/* PThread types */
+/* PThread Types */
 typedef struct posix_thread_attr posix_thread_attr_t;
 
-/* Clock types */
+/* Clock Types */
 typedef long posix_clock_t;
 typedef int posix_clockid_t;
Index: uspace/lib/posix/sys/wait.c
===================================================================
--- uspace/lib/posix/sys/wait.c	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/sys/wait.c	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -31,5 +31,5 @@
  * @{
  */
-/** @file
+/** @file Support for waiting.
  */
 
@@ -65,3 +65,2 @@
 /** @}
  */
-
Index: uspace/lib/posix/sys/wait.h
===================================================================
--- uspace/lib/posix/sys/wait.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/sys/wait.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -30,5 +30,5 @@
  * @{
  */
-/** @file
+/** @file Support for waiting.
  */
 
Index: uspace/lib/posix/time.c
===================================================================
--- uspace/lib/posix/time.c	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/time.c	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -31,5 +31,5 @@
  * @{
  */
-/** @file
+/** @file Time measurement support.
  */
 
@@ -63,4 +63,9 @@
 #define SECS_PER_DAY (SECS_PER_HOUR * HOURS_PER_DAY)
 
+/**
+ *
+ * @param year
+ * @return
+ */
 static bool _is_leap_year(time_t year)
 {
@@ -76,4 +81,10 @@
 }
 
+/**
+ *
+ * @param year
+ * @param mon
+ * @return
+ */
 static int _days_in_month(time_t year, time_t mon)
 {
@@ -92,4 +103,11 @@
 }
 
+/**
+ *
+ * @param year
+ * @param mon
+ * @param mday
+ * @return
+ */
 static int _day_of_year(time_t year, time_t mon, time_t mday)
 {
@@ -102,5 +120,10 @@
 }
 
-/* Integer division that rounds to negative infinity.
+/**
+ * Integer division that rounds to negative infinity.
+ *
+ * @param op1
+ * @param op2
+ * @return
  */
 static time_t _floor_div(time_t op1, time_t op2)
@@ -113,5 +136,10 @@
 }
 
-/* Modulo that rounds to negative infinity.
+/**
+ * Modulo that rounds to negative infinity.
+ *
+ * @param op1
+ * @param op2
+ * @return
  */
 static time_t _floor_mod(time_t op1, time_t op2)
@@ -132,4 +160,11 @@
 }
 
+/**
+ *
+ * @param year
+ * @param mon
+ * @param mday
+ * @return
+ */
 static time_t _days_since_epoch(time_t year, time_t mon, time_t mday)
 {
@@ -139,5 +174,10 @@
 }
 
-/* Assumes normalized broken-down time. */
+/**
+ * Assumes normalized broken-down time.
+ *
+ * @param tm
+ * @return
+ */
 static time_t _secs_since_epoch(const struct posix_tm *tm)
 {
@@ -147,4 +187,11 @@
 }
 
+/**
+ * 
+ * @param year
+ * @param mon
+ * @param mday
+ * @return
+ */
 static int _day_of_week(time_t year, time_t mon, time_t mday)
 {
@@ -165,4 +212,9 @@
 };
 
+/**
+ *
+ * @param ltm
+ * @param ptm
+ */
 static void _posix_to_long_tm(struct _long_tm *ltm, struct posix_tm *ptm)
 {
@@ -179,4 +231,9 @@
 }
 
+/**
+ *
+ * @param ptm
+ * @param ltm
+ */
 static void _long_to_posix_tm(struct posix_tm *ptm, struct _long_tm *ltm)
 {
@@ -196,4 +253,8 @@
 }
 
+/**
+ * 
+ * @param tm
+ */
 static void _normalize_time(struct _long_tm *tm)
 {
@@ -241,6 +302,10 @@
 }
 
-/* Which day the week-based year starts on relative to the first calendar day.
+/**
+ * Which day the week-based year starts on relative to the first calendar day.
  * E.g. if the year starts on December 31st, the return value is -1.
+ *
+ * @param year
+ * @return
  */
 static int _wbyear_offset(int year)
@@ -250,6 +315,10 @@
 }
 
-/* Returns week-based year of the specified time.
+/**
+ * Returns week-based year of the specified time.
  * Assumes normalized broken-down time.
+ *
+ * @param tm
+ * @return
  */
 static int _wbyear(const struct posix_tm *tm)
@@ -268,7 +337,8 @@
 }
 
-/** Week number of the year, assuming weeks start on sunday.
- *  The first Sunday of January is the first day of week 1;
- *  days in the new year before this are in week 0.
+/**
+ * Week number of the year, assuming weeks start on sunday.
+ * The first Sunday of January is the first day of week 1;
+ * days in the new year before this are in week 0.
  *
  * @param tm Normalized broken-down time.
@@ -281,9 +351,10 @@
 }
 
-/** Week number of the year, assuming weeks start on monday.
- *  If the week containing January 1st has four or more days in the new year,
- *  then it is considered week 1. Otherwise, it is the last week of the previous
- *  year, and the next week is week 1. Both January 4th and the first Thursday
- *  of January are always in week 1.
+/**
+ * Week number of the year, assuming weeks start on monday.
+ * If the week containing January 1st has four or more days in the new year,
+ * then it is considered week 1. Otherwise, it is the last week of the previous
+ * year, and the next week is week 1. Both January 4th and the first Thursday
+ * of January are always in week 1.
  *
  * @param tm Normalized broken-down time.
@@ -305,7 +376,8 @@
 }
 
-/** Week number of the year, assuming weeks start on monday.
- *  The first Monday of January is the first day of week 1;
- *  days in the new year before this are in week 0. 
+/**
+ * Week number of the year, assuming weeks start on monday.
+ * The first Monday of January is the first day of week 1;
+ * days in the new year before this are in week 0. 
  *
  * @param tm Normalized broken-down time.
@@ -324,4 +396,7 @@
 char *posix_tzname[2];
 
+/**
+ * 
+ */
 void posix_tzset(void)
 {
@@ -333,4 +408,10 @@
 }
 
+/**
+ * 
+ * @param time1
+ * @param time0
+ * @return
+ */
 double posix_difftime(time_t time1, time_t time0)
 {
@@ -338,9 +419,10 @@
 }
 
-/** This function first normalizes the provided broken-down time
- *  (moves all values to their proper bounds) and then tries to
- *  calculate the appropriate time_t representation.
- *
- * @param timeptr Broken-down time.
+/**
+ * This function first normalizes the provided broken-down time
+ * (moves all values to their proper bounds) and then tries to
+ * calculate the appropriate time_t representation.
+ *
+ * @param tm Broken-down time.
  * @return time_t representation of the time, undefined value on overflow
  */
@@ -358,4 +440,9 @@
 }
 
+/**
+ *
+ * @param timer
+ * @return
+ */
 struct posix_tm *posix_gmtime(const time_t *timer)
 {
@@ -364,4 +451,10 @@
 }
 
+/**
+ * 
+ * @param timer
+ * @param result
+ * @return
+ */
 struct posix_tm *posix_gmtime_r(const time_t *restrict timer,
     struct posix_tm *restrict result)
@@ -394,5 +487,5 @@
 /**
  *
- * @param timep
+ * @param timer
  * @return
  */
@@ -403,4 +496,10 @@
 }
 
+/**
+ * 
+ * @param timer
+ * @param result
+ * @return
+ */
 struct posix_tm *posix_localtime_r(const time_t *restrict timer,
     struct posix_tm *restrict result)
@@ -413,5 +512,5 @@
 /**
  *
- * @param tm
+ * @param timeptr
  * @return
  */
@@ -422,4 +521,10 @@
 }
 
+/**
+ * 
+ * @param timeptr
+ * @param buf
+ * @return
+ */
 char *posix_asctime_r(const struct posix_tm *restrict timeptr,
     char *restrict buf)
@@ -448,5 +553,5 @@
 /**
  * 
- * @param timep
+ * @param timer
  * @return
  */
@@ -460,4 +565,10 @@
 }
 
+/**
+ * 
+ * @param timer
+ * @param buf
+ * @return
+ */
 char *posix_ctime_r(const time_t *timer, char *buf)
 {
@@ -477,6 +588,6 @@
  * @return
  */
-size_t posix_strftime(char *s, size_t maxsize,
-    const char *format, const struct posix_tm *tm)
+size_t posix_strftime(char *restrict s, size_t maxsize,
+    const char *restrict format, const struct posix_tm *restrict tm)
 {
 	// TODO: use locale
@@ -655,4 +766,27 @@
 }
 
+/**
+ * 
+ * @param s
+ * @param maxsize
+ * @param format
+ * @param tm
+ * @param loc
+ * @return
+ */
+extern size_t posix_strftime_l(char *restrict s, size_t maxsize,
+    const char *restrict format, const struct posix_tm *restrict tm,
+    posix_locale_t loc)
+{
+	// TODO
+	not_implemented();
+}
+
+/**
+ *
+ * @param clock_id
+ * @param res
+ * @return
+ */
 int posix_clock_getres(posix_clockid_t clock_id, struct posix_timespec *res)
 {
@@ -670,4 +804,10 @@
 }
 
+/**
+ * 
+ * @param clock_id
+ * @param tp
+ * @return
+ */
 int posix_clock_gettime(posix_clockid_t clock_id, struct posix_timespec *tp)
 {
@@ -688,4 +828,10 @@
 }
 
+/**
+ * 
+ * @param clock_id
+ * @param tp
+ * @return
+ */
 int posix_clock_settime(posix_clockid_t clock_id,
     const struct posix_timespec *tp)
@@ -706,4 +852,12 @@
 }
 
+/**
+ * 
+ * @param clock_id
+ * @param flags
+ * @param rqtp
+ * @param rmtp
+ * @return
+ */
 int posix_clock_nanosleep(posix_clockid_t clock_id, int flags,
     const struct posix_timespec *rqtp, struct posix_timespec *rmtp)
@@ -735,4 +889,11 @@
 };
 
+/**
+ * 
+ * @param clockid
+ * @param evp
+ * @param timerid
+ * @return
+ */
 int posix_timer_create(posix_clockid_t clockid,
     struct posix_sigevent *restrict evp,
@@ -743,4 +904,9 @@
 }
 
+/**
+ * 
+ * @param timerid
+ * @return
+ */
 int posix_timer_delete(posix_timer_t timerid)
 {
@@ -749,4 +915,9 @@
 }
 
+/**
+ * 
+ * @param timerid
+ * @return
+ */
 int posix_timer_getoverrun(posix_timer_t timerid)
 {
@@ -755,4 +926,10 @@
 }
 
+/**
+ * 
+ * @param timerid
+ * @param value
+ * @return
+ */
 int posix_timer_gettime(posix_timer_t timerid,
     struct posix_itimerspec *value)
@@ -762,4 +939,12 @@
 }
 
+/**
+ * 
+ * @param timerid
+ * @param flags
+ * @param value
+ * @param ovalue
+ * @return
+ */
 int posix_timer_settime(posix_timer_t timerid, int flags,
     const struct posix_itimerspec *restrict value,
@@ -783,7 +968,7 @@
 	if (task_stats) {
 		total_cycles = (posix_clock_t) (task_stats->kcycles + task_stats->ucycles);
-	}
-	free(task_stats);
-	task_stats = 0;
+		free(task_stats);
+		task_stats = 0;
+	}
 
 	return total_cycles;
Index: uspace/lib/posix/time.h
===================================================================
--- uspace/lib/posix/time.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/time.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -31,5 +31,5 @@
  * @{
  */
-/** @file
+/** @file Time measurement support.
  */
 
@@ -94,17 +94,14 @@
 
 /* Timezones */
-
 extern int posix_daylight;
 extern long posix_timezone;
 extern char *posix_tzname[2];
-
 extern void posix_tzset(void);
 
-/* time_t */
-
+/* Elapsed Time */
 extern double posix_difftime(time_t time1, time_t time0);
 
 /* Broken-down Time */
-extern time_t posix_mktime(struct posix_tm *timeptr);
+extern time_t posix_mktime(struct posix_tm *tm);
 extern struct posix_tm *posix_gmtime(const time_t *timer);
 extern struct posix_tm *posix_gmtime_r(const time_t *restrict timer,
@@ -120,14 +117,11 @@
 extern char *posix_ctime(const time_t *timer);
 extern char *posix_ctime_r(const time_t *timer, char *buf);
-
 extern size_t posix_strftime(char *restrict s, size_t maxsize,
     const char *restrict format, const struct posix_tm *restrict tm);
-
 extern size_t posix_strftime_l(char *restrict s, size_t maxsize,
     const char *restrict format, const struct posix_tm *restrict tm,
     posix_locale_t loc);
 
-/* Clocks. */
-
+/* Clocks */
 extern int posix_clock_getres(posix_clockid_t clock_id,
     struct posix_timespec *res);
@@ -139,8 +133,7 @@
     const struct posix_timespec *rqtp, struct posix_timespec *rmtp);
 
-/* Timers. */
-
 #if 0
 
+/* Timers */
 extern int posix_timer_create(posix_clockid_t clockid,
     struct posix_sigevent *restrict evp,
@@ -159,13 +152,17 @@
 extern posix_clock_t posix_clock(void);
 
-
 #ifndef LIBPOSIX_INTERNAL
 	#define tm posix_tm
-
 	#define timespec posix_timespec
 	#define itimerspec posix_itimerspec
 	#define timer_t posix_timer_t
 
+	#define daylight posix_daylight
+	#define timezone posix_timezone
+	#define tzname posix_tzname
+	#define tzset posix_tzset
+
 	#define difftime posix_difftime
+
 	#define mktime posix_mktime
 	#define gmtime posix_gmtime
@@ -174,9 +171,4 @@
 	#define localtime_r posix_localtime_r
 
-	#define daylight posix_daylight
-	#define timezone posix_timezone
-	#define tzname posix_tzname
-	#define tzset posix_tzset
-
 	#define asctime posix_asctime
 	#define asctime_r posix_asctime_r
@@ -184,4 +176,5 @@
 	#define ctime_r posix_ctime_r
 	#define strftime posix_strftime
+	#define strftime_l posix_strftime_l
 
 	#define clock_getres posix_clock_getres
